﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace WindowSL
{
    public class DialogKeyHelper
    {


        public static bool GetIsKeyEnabled(DependencyObject obj)
        {
            return (bool)obj.GetValue(IsKeyEnabledProperty);
        }

        public static void SetIsKeyEnabled(DependencyObject obj, bool value)
        {
            obj.SetValue(IsKeyEnabledProperty, value);
        }

        // Using a DependencyProperty as the backing store for IsKeyEnabled.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsKeyEnabledProperty =
            DependencyProperty.RegisterAttached("IsKeyEnabled", typeof(bool), typeof(DialogKeyHelper), new PropertyMetadata(false, OnIsKeEnabledChanged));

        private static void OnIsKeEnabledChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            if (e.NewValue != e.OldValue)
            {
                var wind = d as RadAlert;

                wind.RemoveHandler(UIElement.KeyDownEvent, new KeyEventHandler(OnKeyDownEventHandler));

                if ((bool)e.NewValue)
                {
                    wind.AddHandler(UIElement.KeyDownEvent, new KeyEventHandler(OnKeyDownEventHandler), true);
                }
            }
        }

        private static void OnKeyDownEventHandler(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Escape)
            {
                ((sender as RadAlert).Parent as RadWindow).Close();
            }
        }
    }
}
